#ifndef __intellisense__

declare extern isLookupKeyword(LPSTR pszKeyword),LPSTR;
declare extern isLookupKeywordLocation(string *pszKeyword,string *pszFilePath, int *ppfilePosition),BOOL;
declare extern GetCurrentSourceFilePath(),string*;
declare extern FindInclude(string *pszFileName, string *pszFolder, string *pszPath),BOOL;

#else

struct DBKEYWORD,1
{
	int fileIndex;    // index in DBFILES
	int filePosition;
	dstring name[1]; // ExpandEnvironmentStrings 21 + 24
}

struct DBGROUP,1
{
	int nKeywordCount;
	int offsets[0];   // offset to DBKEYWORD, form beginning of DBGROUP
	DBKEYWORD keywords[0];
}


struct DBFILES,1
{
	int size;       // total size of DBFILES
	int count;      // function isLookupKeyword requires that 'count' is right after 'size'
	int offsets[0]; // from DBFILES
	// paths here   D:\Aurora\include\winbase.h  21+27=48
}

struct DBHEADER,1
{
	GUID signature;   // {4364A21C-BFE6-46A9-8803-973CA3874D78}
	int offsets[128]; // offsets to DBGROUP; MessageBox is in offsets['M'] group
	int sizes[128];   // DBGROUP sizes

//	DBFILES files;
//	DBGROUP groups[];
}


/////////////////////////////
struct DBMEMORY
{
	DBMEMORY *next;
	void     *pFree;
	int       nBytesLeft;
}

// to create database
struct DBDESCRIPTOR
{
	int    nIncludeFilesCount;
	int    nIncludeFilesAllocated;
	LPSTR *pszIncludeFiles;
	//
	int    nKeywordsCount;
	int    nKeywordsAllocated;
	pointer *keywords; // DBKEYWORD* array; sorted by name
	//
	DBMEMORY *memory;
}
// to allocate DBDESCRIPTOR use new().
// to allocate its members, use dbnew / dbdelete.

#endif
